#include <bits/stdc++.h>

using namespace std;

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;

template <typename T>
using ordered_set = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define CE constexpr

#ifdef DBG
#define debugf(s, ...) fprintf(stderr, "(" #__VA_ARGS__ ") " s "\n", __VA_ARGS__)
#else
#define debugf(...) void(0)
#endif

using i16 = int16_t;
using u16 = uint16_t;
using i32 = int32_t;
using u32 = uint32_t;
using i64 = int64_t;
using i128 = __int128;
using u64 = uint64_t;
using u128 = unsigned __int128;

u16 take_bit(u16 word, u16 bit) {
    return (word << 4) + bit;
}


u16 instructions[1 << 12]{0, 0,0,0, 0, 0xffff};


void gen_bbj(u16 word1, u16 bit1, u16 word2, u16 bit2, u16 go_to, u16 place) {
    instructions[place] = take_bit(word1, bit1);
    instructions[place + 1] = take_bit(word2, bit2);
    instructions[place + 2] = go_to;
}


constexpr u16 IO_WORD = (1 << 12) - 1;
constexpr u16 PREIO_WORD = IO_WORD - 1;
constexpr u16 IBLOCK = 16;

constexpr u16 WORD_0 = 4;
constexpr u16 WORD_1 = 5;


void gen_negative(u16 place) {
    gen_bbj(WORD_0, 0, IO_WORD, 0, IO_WORD, place);
}

void gen_positive(u16 place) {
    gen_bbj(WORD_1, 0, IO_WORD, 0, IO_WORD, place);
}

void gen_simple(u16 go_to, u16 place) {
    gen_bbj(WORD_0, 0, WORD_0, 0, go_to, place);
}

//bool run(u16 x) {
//    vector<u16> ic(1 << 12);
//    copy_n(instructions, 1 << 12, ic.begin());
//    ic.back() = x;
//    u16 op = 0;
//    while (op + 2 <= IO_WORD) {
//        ic[ic[op] >> 4] 
//    }
//}

void solve() {

    u16 x;
    cin >> x;

    u16 cur_instruction = IBLOCK;
    gen_simple(IBLOCK, 0);

    for (u16 bit = 0; bit < 16; ++bit) {
        u16 next_instruction = cur_instruction + IBLOCK;
        gen_bbj(WORD_1, bit, PREIO_WORD, bit, next_instruction, cur_instruction);
        cur_instruction = next_instruction;
    }

    for (u16 bit = 0; bit < 16; ++bit) {
        u16 next_instruction = cur_instruction + IBLOCK;
        gen_bbj(IO_WORD, bit, cur_instruction + 2, 3, cur_instruction + 4, cur_instruction);
        gen_simple(next_instruction, cur_instruction + 4);
        gen_bbj(WORD_0, bit, PREIO_WORD, bit, next_instruction, cur_instruction + 12);
        cur_instruction = next_instruction;
    }

    for (u16 bit = 0; bit < 16; ++bit) {
        u16 next_instruction = cur_instruction + IBLOCK;
        gen_bbj((x >> bit) & 1 ? PREIO_WORD : IO_WORD, bit, cur_instruction + 2, 3, cur_instruction + 4, cur_instruction);
        gen_simple(next_instruction, cur_instruction + 4);
        gen_negative(cur_instruction + 12);
        cur_instruction = next_instruction;
    }
    gen_positive(cur_instruction);

    vector<u16> ops(instructions, instructions + IO_WORD);
    while (ops.back() == 0) {
        ops.pop_back();
    }

    for (auto &e: ops) {
        for (int i = 3; i >= 0; --i) {
            cout << hex << ((e >> (4 * i)) & 15);
        }
        cout << ' ';
    }
    cout << '\n';
}


int main() {
#ifndef DBG
    std::ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int t = 1;

//    cin >> t;
    for (int i = 0; i < t; ++i) { solve(); }
    return 0;
}