# Generates correct solution exceeding maximum length by one

io_word = 0x0fff
io_addr = io_word * 16

def instruction(ip, a, b, c = None):
    if c == None:
        c = ip + 3

    assert 0 <= a < 2 ** 16
    assert 0 <= b < 2 ** 16
    assert 0 <= c < 2 ** 16

    program[ip + 0] = a
    program[ip + 1] = b
    program[ip + 2] = c

end = 0xfff

x = int(input())

program = [0] * (io_word + 1)
prev_bit = 0
for i in range(16):
    ip1 = i * 3
    ip2 = ip1 + 64
    if prev_bit == 0:
        instruction(ip1, io_addr + i, (ip1 + 2) * 16 + 6)
        instruction(ip2, 0, io_addr, end)
    else:
        instruction(ip1, 0, io_addr, end)
        instruction(ip2, io_addr + i, (ip2 + 2) * 16 + 6)
    prev_bit = (x >> i) & 1
if prev_bit == 0:
    instruction(16 * 3, 4, io_addr, end)
    instruction(16 * 3 + 64, 0, io_addr, end)
else:
    instruction(16 * 3, 0, io_addr, end)
    instruction(16 * 3 + 64, 4, io_addr, end)

for w in program:
    print(f'{w:04x} ', end='')
