#include <bits/stdc++.h>
using namespace std;

const int MAXN = 1e5 + 100;
vector<int> g[MAXN];
int d[MAXN], up[MAXN];
int par[MAXN];
int sz[MAXN];

map<array<int, 2>, int> id;
int ans[2 * MAXN];

void calc_d(int v, int p = -1) {
    par[v] = p;
    up[v] = d[v];
    /// cerr << v << "->" << p << endl;
    for (int u : g[v]) {
        if (d[u] != -1 && d[u] < d[v]) ++sz[v];
        if (u == p) continue;
        if (d[u] == -1) {
            d[u] = d[v] + 1;
            calc_d(u, v);
            up[v] = min(up[v], up[u]);
            sz[v] += sz[u];
        } else {
            up[v] = min(up[v], d[u]);
        }
    }
}

vector<int> get_cycle(int v, int ch) {
    assert(up[ch] == d[v]);
    vector<int> res = {v, ch};
    while (true) {
        int ch2 = -1;
        for (int u : g[ch]) {
            if (par[u] != ch) continue;
            if (up[u] == up[ch]) {
                ch2 = u;
                break;
            }
        }
        if (ch2 == -1) break;
        res.push_back(ch2);
        v = ch;
        ch = ch2;
    }
    return res;
}

void col(int v, int x, int y);

void col_cyc(int v, int ch, int x, int y) {
    if (x > y) swap(x, y);
    vector<int> cyc =  get_cycle(v, ch);
    int n = cyc.size();
    vector<int> col(n);
    col[0] = 0;
    for (int i = 1; i < n; ++i) {
        int u = cyc[i];
        int parity = 0;
        for (int w : g[u]) {
            if (par[w] == u && up[w] == d[u]) {
                parity ^= (sz[w] & 1);
            }
        }
        if (parity == 0) {
            col[i] = col[i - 1] ^ 1;
        } else {
            col[i] = col[i - 1] ^ 2;
        }
    }
    if (col[n - 1] == 0) {
        bool found = false;
        for (int i = 1; i < n && !found; ++i) {
            if (col[i - 1] ^ col[i] == 1) {
                if (col[i - 1] == 0 || col[i - 1] == 3) {
                    for (int j = 0; j < i; ++j) {
                        col[j] ^= 2;
                    }
                } else {
                    for (int j = i; j < n; ++j) {
                        col[j] ^= 2;
                    }
                }
                found = true;
            }
        }
        assert(found);
    }
    if (col[n - 1] == 3) {
        for (int i = 0; i < n; ++i) {
            col[i] ^= 2;
        }
    }
    int mn = min(col[0], col[n - 1]);
    assert(max(col[0], col[n - 1]) - mn == y - x);
    for (int i = 0; i < n; ++i) {
        col[i] += x - mn;
        int u = cyc[i], v = cyc[(i + 1) % n];
        ans[id[{u, v}]] = col[i];
    }
    for (int i = 1; i < n; ++i) {
        ::col(cyc[i], col[i - 1], col[i]);
    }
}

void col(int v, int x, int y) {
    vector<int> odd, even;
    for (int u : g[v]) {
        if (par[u] != v) continue;
        if (up[u] < d[v]) continue;
        if (sz[u] % 2 == 0) {
            even.push_back(u);
        } else {
            odd.push_back(u);
        }
    }
    if (x > y) swap(x, y);
    int start = y + 1;
    if (y == x + 2) {
        assert(odd.size() % 2 == 1);
        col_cyc(v, odd.back(), x + 1, x + 3);
        odd.pop_back();
        start = x + 4;
    } else {
        assert(y == x + 1);
        assert(odd.size() % 2 == 0);
    }
    while (!odd.empty()) {
        int u = odd.back();
        odd.pop_back();
        col_cyc(v, u, start, start + 2);
        u = odd.back();
        odd.pop_back();
        col_cyc(v, u, start + 1, start + 3);
        start += 4;
    }
    while (!even.empty()) {
        int u = even.back();
        even.pop_back();
        col_cyc(v, u, start, start + 1);
        start += 2;
    }
}

void solve_() {
    int n, m;
    cin >> n >> m;
    if (m % 2 == 1) {
        cout << "NO\n";
        return;
    }
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u; --v;
        id[{u, v}] = id[{v, u}] = i;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    fill(d, d + n, -1);
    d[0] = 0;
    calc_d(0);
    col(0, 0, 1);
    int mn = 1e9, mx = -1e9;
    for (int i = 0; i < m; ++i) {
        mn = min(mn, ans[i]);
        mx = max(mx, ans[i]);
    }
    cout << "YES\n";
    cout << mx - mn + 1 << "\n";
    for (int i = 0; i < m; ++i) {
        cout << ans[i] - mn + 1 << " ";
    }
    cout << "\n";
}

/// #define MULTITEST

signed main() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#endif
    int tst = 1;
#ifdef MULTITEST
    cin >> tst;
#endif // MULTITEST
    while (tst--) {
        solve_();
    }
    return 0;
}