#include <bits/stdc++.h>
using namespace std;
#ifndef DEBUG
#define cerr if (false) cerr
#endif

typedef long long ll;
typedef long double ld;

const int MAXN = 4e5 + 10;

int n;

vector<int> g[MAXN];
vector<int> gr[MAXN];

// 0  u f
// 1 u t
// 2 s f
// 3 s t
int tp[MAXN];

int acc[MAXN];
int acc_rev[MAXN];

void label(int v) {
    acc[v] = 1;
    for (auto to : g[v]) {
        if (acc[to]) continue;
        label(to);
    }
}
void label_rev(int v) {
    acc_rev[v] = 1;
    for (auto to : gr[v]) {
        if (acc_rev[to]) continue;
        label_rev(to);
    }
}


vector<int> topsort;
int used[MAXN];

void dfs(int v) {
    if (used[v]) return;
    used[v] = 1;
    for (auto to : g[v]) {
        dfs(to);
    }
    topsort.push_back(v);
}

int rev_topsort[MAXN];

void solve() {
    memset(used, 0, sizeof(used));
    memset(acc_rev, 0, sizeof(acc_rev));
    memset(acc, 0, sizeof(acc));
    topsort.clear();
    int trues = 0;
    for (int i = 0; i < n; i++) {
        tp[i] = 0;
        g[i].clear();
        gr[i].clear();
        string a, b;
        cin >> a >> b;
        if (a[0] == 's') {
            tp[i] += 2;
        }
        if (b[0] == 't') {
            tp[i] += 1;
            trues++;
        }
    }
    int m;
    cin >> m;
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        g[a].push_back(b);
        gr[b].push_back(a);
    }
    if (trues > 2) {
        cout << "-1\n";
        return;
    }
    int pos = -1;
    for (int i = 0; i < n; i++) {
        if (tp[i] == 3) {
            if (pos != -1) {
                cout << "-1\n";
                return;
            }
            pos = i;
        }
    }
    int pos2 = -1;
    for (int i = 0; i < n; i++) {
        if (tp[i] == 1) {
            if (pos2 != -1) {
                cout << "-1\n";
                return;
            }
            pos2 = i;
        }
    }

    if (pos2 != -1 && pos == -1) {
        cout << "-1\n";
        return;
    }

    if (pos2 != -1) {
        g[pos].push_back(pos2);
        gr[pos2].push_back(pos);
    }
    for (int i = 0; i < n; i++) {
        if (tp[i] == 2) {
            if (pos != -1) {
                g[pos].push_back(i);
                gr[i].push_back(pos);   
            }
            if (pos2 != -1) {
                g[i].push_back(pos2);
                gr[pos2].push_back(i);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (tp[i] != 0 && !acc[i]) {
            label(i);
        }
    }
    for (int i = 0; i < n; i++) {
        if (acc[i] && tp[i] == 0) {
            if (pos != -1) {
                g[pos].push_back(i);
                gr[i].push_back(pos);
            }
            if (pos2 != -1) {
                g[pos2].push_back(i);
                gr[i].push_back(pos2);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (tp[i] != 0 && !acc_rev[i]) {
            label_rev(i);
        }
    }
    
    for (int i = 0; i < n; i++) {
        if (tp[i] == 0 && acc[i] == 0 && acc_rev[i] == 0){
            acc_rev[i] = 1;
        }
    }
    for (int i = 0; i < n; i++) {
        if (acc_rev[i] && tp[i] == 0) {
            if (pos != -1) {
                g[i].push_back(pos);
                gr[pos].push_back(i);
            }
            if (pos2 != -1) {
                g[i].push_back(pos2);
                gr[pos2].push_back(i);
            }
        }
    }

    for (int i = 0; i < n; i++) {
        dfs(i);
    }
    reverse(topsort.begin(), topsort.end());
    for (int i = 0; i < n; i++) {
        rev_topsort[topsort[i]] = i;
    }
    int start = 0;
    for (int x : topsort) {
        cerr << x << ' ' << start << ' ' <<  tp[x] << '\n';
        if (start && (tp[x] == 0 || tp[x] == 3) ||
            !start && (tp[x] == 1 || tp[x] == 2)) {
            cerr << "BAD\n";
            cout << "-1\n";
            return;
        }
        if (tp[x] & 1) start ^= 1;
    }
    for (int i = 0; i < n; i++) {
        for (auto to : g[i]) {
            if (rev_topsort[i] > rev_topsort[to]) {
                cerr << "bad edge " << i << ' ' << to << '\n';
                cout << "-1\n";
                return;
            }
        }
    }
    for (auto x : topsort) {
        cout << x + 1 << ' ';
    }
    cout << '\n';    
}

signed main() {
    #ifdef DEBUG
        freopen("input.in", "r", stdin);
        freopen("output.out", "w", stdout);
    #endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    while (cin >> n)
        solve();
}