#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_set>

using namespace std;

// #define int long long
typedef long long ll;
typedef long double ld;
const int MAXN = 1e6;
int op_t[MAXN];
vector<int> adj[MAXN];
vector<int> topsort;
bool been[MAXN];
int t_out[MAXN];
int curr_t = 0;

void dfs(int u) {
    been[u] = true;
    for (auto v : adj[u]) {
        if (!been[v]) {
            dfs(v);
        }
    }
    topsort.push_back(u);
    t_out[u] = curr_t;
    curr_t += 1;
}

bool make_topsort(int n) {
    for (int i = 0; i < n; ++i) {
        been[i] = false;
    }
    for (int i = 0; i < n; ++i) {
        if (!been[i]) {
            dfs(i);
        }
    }
    reverse(topsort.begin(), topsort.end());
    for (int i = 0; i < n; ++i) {
        for (auto j : adj[i]) {
            if (t_out[j] >= t_out[i]) {
                topsort.clear();
                topsort.push_back(-2);
                return false;
            }
        }
    }
    return true;
}

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> ops(4);
    for (int i = 0; i < n; ++i) {
        string s1, s2;
        cin >> s1 >> s2;
        if (s1 == "set") {
            if (s2 == "true") {
                op_t[i] = 1;
            }
            else {
                op_t[i] = 2;
            }
        }
        else {
            if (s2 == "true") {
                op_t[i] = 3;
            }
            else {
                op_t[i] = 0;
            }
        }
        ops[op_t[i]].push_back(i);
    }
    int m;
    cin >> m;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u; --v;
        adj[u].push_back(v);
    }
    if (ops[0].size() == n) {
        make_topsort(n);
        for (auto elem : topsort) {
            cout << elem + 1 << " ";
        }
        cout << "\n";
        return;
    }
    if (ops[1].size() != 1) {
        cout << "-1\n";
        return;
    }
    if (ops[0].size() + ops[1].size() + ops[2].size() == n) {
        for (auto elem : ops[0]) {
            adj[elem].push_back(ops[1][0]);
        }
        for (auto elem : ops[2]) {
            adj[ops[1][0]].push_back(elem);
        }
        make_topsort(n);
        for (auto elem : topsort) {
            cout << elem + 1 << " ";
        }
        cout << "\n";
        return;
    }
    if (ops[3].size() != 1) {
        cout << "-1\n";
        return;
    }

    for (auto elem : ops[2]) {
        adj[ops[1][0]].push_back(elem);
        adj[elem].push_back(ops[3][0]);
    }
    adj[ops[1][0]].push_back(ops[3][0]);
    for (auto elem : ops[0]) {
        bool found = false;
        for (auto to : adj[elem]) {
            if (op_t[to] != 0) {
                found = true;
            }
        }
        if (found) {
            adj[elem].push_back(ops[1][0]);
        }
    }
    unordered_set<int> help;
    for (int i = 0; i < n; ++i) {
        if (op_t[i] == 0) continue;
        for (auto to : adj[i]) {
            if (op_t[to] == 0) {
                help.insert(to);
            }
        }
    }
    for (auto elem : help) {
        adj[ops[3][0]].push_back(elem);
    }
    make_topsort(n);
    if (topsort.size() == n) {
        vector<bool> is_bad(n, false);
        vector<int> baddies;
        for (auto elem : ops[0]) {
            if (t_out[ops[1][0]] > t_out[elem] && t_out[elem] > t_out[ops[3][0]]) {
                is_bad[elem] = true;
                baddies.push_back(elem);
            }
        }
        vector<int> new_topsort;
        int i = 0;
        while (op_t[topsort[i]] != 1) {
            new_topsort.push_back(topsort[i]);
            ++i;
        }
        for (auto elem : baddies) {
            new_topsort.push_back(elem);
        }
        while (op_t[topsort[i]] != 3) {
            if (op_t[topsort[i]] != 0) {
                new_topsort.push_back(topsort[i]);
            }
            ++i;
        }
        while (i < n) {
            new_topsort.push_back(topsort[i]);
            ++i;
        }
        topsort = new_topsort;
    }
    for (auto elem : topsort) {
        cout << elem + 1 << " ";
    }
    cout << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LC
    freopen("/Users/Iurii.Zaitsev/TUM/ICPC/y1/nerc_test/input.txt", "r", stdin);
    freopen("/Users/Iurii.Zaitsev/TUM/ICPC/y1/nerc_test/output.txt", "w", stdout);

#endif
    int t = 1;
    // cin >> t;
    for (int tt =0; tt < t; tt++) {
        solve();
    }

    return 0;
}
