#include <bits/stdc++.h>
#include "testlib.h"
 
using namespace std;
 
typedef long long ll;
 
ll INF = 1e18 + 10;
 
template <class T>
bool smin(T & x, T y) {
    if (x > y) {
        x = y;
        return true;
    }
    return false;
}
 
ll calc(int n, vector<vector<bool>> & f) {
    vector<vector<ll>> dp(n + 1, vector<ll>(4));
    dp[0][0] = 1;
    for (int i = 0; i < n; ++i) {
        if (!f[0][i] && !f[1][i]) {
            dp[i + 1][0] = dp[i][0] + dp[i][3];
            smin(dp[i + 1][0], INF);
            dp[i + 1][1] = dp[i][2];
            dp[i + 1][2] = dp[i][1];
            dp[i + 1][3] = dp[i][0];
        } else if (!f[0][i] && f[1][i]) {
            dp[i + 1][0] = dp[i][1];
            dp[i + 1][1] = dp[i][0];
        } else if (f[0][i] && !f[1][i]) {
            dp[i + 1][0] = dp[i][2];
            dp[i + 1][2] = dp[i][0];
        } else {
            dp[i + 1][0] = dp[i][0];
        }
    }
    return dp[n][0];
}
 
void check(int testnum) {
    setTestCase(testnum);
    int n = inf.readInt();
    int m = inf.readInt();
    ll k = inf.readLong();
    auto readAns = [&](InStream& stream) {
        string res = upperCase(stream.readWord("[Yy][Ee][Ss]|[Nn][Oo]", "answer"));
        if (res == "YES") {
            vector<string> field(2);
            for (int i = 0; i < 2; ++i) {
                field[i] = stream.readWord(format("[\\.#]{%d}", n).c_str(), "field_i");
            }
            int count = 0;
            vector<vector<bool>> f(2, vector<bool>(n));
            for (int i = 0; i < 2; ++i) {
                for (int j = 0; j < n; ++j) {
                    f[i][j] = field[i][j] == '#';
                    if (f[i][j]) {
                        ++count;
                    }
                }
            }
            if (count != m) {
                stream.quitf(_wa, "test %d: number of # %d differs from required %d", count, m);
            }
            if (calc(n, f) != k) {
                stream.quitf(_wa, "test %d: number of placements is different", testnum);
            }
            return true;
        }
        return false;
    };
    
    bool jans = readAns(ans);
    bool pans = readAns(ouf);
    
    if (jans == pans) {
        return;
    } else if (jans) {
        quitf(_wa, "test %d: jury found the answer, but participant did not", testnum);
    } else if (pans) {
        quitf(_fail, "test %d: participant found the answer, but jury did not", testnum);
    }
}
 
int main(int argc, char** argv) {
    registerTestlibCmd(argc, argv);
    int t = inf.readInt();
    for (int it = 1; it <= t; ++it) {
        check(it);
    }
    quitf(_ok, "ok, tests passed: %d", t);
    return 0;
}
