#include "fibonacci.h"

int main(int argc, char** argv) {
    registerGen(argc, argv, 1);
	int t = opt<int>("maxt");
    int maxn = opt<int>("maxn");
    ll maxk = opt<ll>("maxk");
    int nrand = opt<int>("nrand");

    int sz = 0;
    int sumn = 0;

    init_f();

    int maxid = 0;
    while (maxid < nf && f[maxid] <= maxk) {
        maxid += 1;
    }

    vector<tuple<int, int, ll>> q;

    bool flag = true;
    for (int n = 1; n <= 30; ++n) {
        for (int k = 1; k <= 5; ++k) {
            int m = 0;
            if (sz < t && sumn + n <= MAXSUMN) {
                q.push_back({n, m, k});
                ++sz;
                sumn += n;
            } else {
                flag = false;
                break;
            }
        }
    }

    for (ll fib : f) {
        auto [n0, m0] = min_params(fib);
        for (int n = max(1, n0 - 1); n <= n0 + 3; ++n) {
            int m = 0;
            if (sz < t && sumn + n <= MAXSUMN) {
                q.push_back({n, m, fib});
                ++sz;
                sumn += n;
            } else {
                flag = false;
                break;
            }
        }
        if (!flag) {
            break;
        }
        for (int j = 0; j < nrand; ++j) {
            int n = rnd.next(1, maxn);
            int m = 0;
            if (sz < t && sumn + n <= MAXSUMN) {
                q.push_back({n, m, fib});
                ++sz;
                sumn += n;
            } else {
                flag = false;
                break;
            }
        }
        if (!flag) {
            break;
        }
    }

    for (int randtype : {-100, -20, -10, -5, -3, -2, -1, 0, 1}) {
        while (true) {
            ll fib = 1;
            while (true) {
                int id = rnd.wnext(maxid, randtype);
                if (f[id] <= maxk / fib) {
                    fib *= f[id];
                } else {
                    break;
                }
            }
            auto [n0, m0] = min_params(fib);
            for (int n = max(1, n0 - 1); n <= n0 + 3; ++n) {
                int m = 0;
                if (sz < t && sumn + n <= MAXSUMN) {
                    q.push_back({n, m, fib});
                    ++sz;
                    sumn += n;
                } else {
                    flag = false;
                    break;
                }
            }
            if (!flag) {
                break;
            }
            for (int j = 0; j < nrand; ++j) {
                int n = rnd.next(1, maxn);
                int m = 0;
                if (sz < t && sumn + n <= MAXSUMN) {
                    q.push_back({n, m, fib});
                    ++sz;
                    sumn += n;
                } else {
                    flag = false;
                    break;
                }
            }
            if (!flag) {
                break;
            }
        }
        if (!flag) {
            break;
        }
    }

    cout << sz << "\n";
    for (auto [ni, mi, ki] : q) {
        cout << ni << " " << mi << " " << ki << "\n";
    }
    return 0;
}