#include <bits/stdc++.h>
using namespace std;

using ll = int64_t;

int main(){
	ios_base::sync_with_stdio(false), cin.tie(nullptr);

	auto rot = [&](vector<ll> v) -> vector<ll> {
		return {v[1], v[2], v[3], -v[0]};
	};
	auto fix = [&](vector<tuple<int, vector<ll>, vector<ll> > > segs){
		vector<map<vector<ll>, vector<ll> > > mp(4);
		vector<set<vector<ll> > > en(4);
		for(auto& [dir, a, b] : segs){
			if(dir >= 4){
				dir -= 4;
			}
			if(a > b) swap(a, b);
			mp[dir][a] = b;
			en[dir].insert(b);
		}
		vector<tuple<int, vector<ll>, vector<ll> > > new_segs;
		for(int dir = 0; dir < 4; dir++){
			for(auto& [a, b] : mp[dir]){
				if(en[dir].count(a)){
					continue;
				}
				vector<ll> st = a;
				vector<ll> cur = b;
				while(mp[dir].count(cur)){
					cur = mp[dir][cur];
				}
				new_segs.push_back({dir, st, cur});
			}
		}
		vector<ll> pmin(4, 1e18);
		for(auto& [dir, a, b] : new_segs){
			for(int i = 0; i < 4; i++){
				pmin[i] = min(pmin[i], a[i]);
				pmin[i] = min(pmin[i], b[i]);
			}
		}
		for(auto& [dir, a, b] : new_segs){
			for(int i = 0; i < 4; i++){
				a[i] -= pmin[i];
				b[i] -= pmin[i];
			}
		}
		sort(new_segs.begin(), new_segs.end());
		return new_segs;
	};

	auto rotate = [&](vector<tuple<int, vector<ll>, vector<ll> > > segs, int angle){
		for(auto& [dir, a, b] : segs){
			for(int i = 0; i < angle; i++){
				dir = (dir + 1) % 8;
				a = rot(a);
				b = rot(b);
			}
		}
		return segs;
	};

	int N;
	cin >> N;
	vector<ll> pos = {0, 0, 0, 0};
	vector<vector<ll> > dx;
	dx.push_back({1, 0, 0, 0});
	for(int i = 1; i < 8; i++){
		dx.push_back(rot(dx[i - 1]));
	}

	int cdir = 0;
	vector<ll> cpos = {0, 0, 0, 0};


	vector<tuple<int, vector<ll>, vector<ll> > > segs;
	for(int i = 0; i < N; i++){
		string s;
		cin >> s;
		if(s == "rotate"){
			int a;
			cin >> a;
			cdir = (cdir + a) % 8;
		} else {
			int a;
			cin >> a;
			vector<ll> npos = cpos;
			for(int j = 0; j < 4; j++){
				npos[j] += dx[cdir][j] * a;
			}
			if(s == "draw"){
				segs.push_back({cdir, cpos, npos});
			}
			cpos = npos;
		}
	}
	segs = fix(segs);
	if(segs == fix(rotate(segs, 1))){
		cout << 45 << '\n';
	} else if(segs == fix(rotate(segs, 2))){
		cout << 90 << '\n';
	} else if(segs == fix(rotate(segs, 4))){
		cout << 180 << '\n';
	} else if(segs == fix(rotate(segs, 8))){
		cout << 360 << '\n';
	} else {
		assert(false);
	}
}


