#include <bits/stdc++.h>
using namespace std;
#define int int64_t

struct Num {
    int a;
    int b;

    /// a + b / sqrt(2)

    Num(int a = 0, int b = 0): a(a), b(b) {}
};

Num operator+(const Num& a, const Num& b) {
    return {a.a + b.a, a.b + b.b};
}

Num operator-(const Num& a, const Num& b) {
    return {a.a - b.a, a.b - b.b};
}

Num operator*(const Num& a, int k) {
    return {a.a * k, a.b * k};
}

bool operator<(const Num& a, const Num& b) {
    if (a.b == b.b) return a.a < b.a;
    return a.b < b.b;
}

struct Vector {
    Num x;
    Num y;

    Vector(Num x = 0, Num y = 0): x(x), y(y) {}
};

Vector operator+(const Vector& a, const Vector& b) {
    return {a.x + b.x, a.y + b.y};
}

Vector operator-(const Vector& a, const Vector& b) {
    return {a.x - b.x, a.y - b.y};
}

Vector operator*(const Vector& a, int k) {
    return {a.x * k, a.y * k};
}

Vector rot45(const Vector& a) {
    return {{(a.x.b - a.y.b) / 2, a.x.a - a.y.a}, {(a.x.b + a.y.b) / 2, a.x.a + a.y.a}};
}

vector<int> get(const Vector& a) {
    return {a.x.a, a.x.b, a.y.a, a.y.b};
}

bool operator<(const Vector& a, const Vector& b) {
    return get(a) < get(b);
}

bool operator==(const Vector& a, const Vector& b) {
    return get(a) == get(b);
}

void solve_() {
    int n;
    cin >> n;
    array<vector<array<Vector, 2>>, 4> seg;
    Vector cur = {0, 0};
    Vector dir = {{1, 0}, {0, 0}};
    int di = 0;
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        string tp;
        cin >> tp;
        if (tp == "rotate") {
            int angle;
            cin >> angle;
            while (angle > 0) {
                angle -= 45;
                di = (di + 1) % 4;
                dir = rot45(dir);
            }
        } else {
            int len;
            cin >> len;
            Vector nxt = cur + dir * len;
            if (tp == "draw") {
                seg[di].push_back({cur, nxt});
                /// cerr << di << ": " << cur.x.a << " " << cur.y.a << " " << nxt.x.a << " " << nxt.y.a << endl;
            }
            cur = nxt;
        }
    }
    Vector mid = {0, 0};
    array<vector<pair<int, array<Vector, 2>>>, 4> narr;
    for (int i = 0; i < 4; ++i) {
        /// merge segments
        map<Num, vector<array<Num, 2>>> mp;
        for (auto elem : seg[i]) {
            Vector u = elem[0];
            Vector v = elem[1];
            /// cerr << i << ": " << u.x.a << " " << u.y.a << " " << v.x.a << " " << v.y.a << endl;
            for (int j = 0; j < 8 - i; ++j) {
                u = rot45(u);
                v = rot45(v);
            }
            /// cerr << i << ": " << u.x.a << " " << u.y.a << " " << v.x.a << " " << v.y.a << endl;
            assert(u.y == v.y);
            assert(u.x.b == v.x.b);
            if (v.x < u.x) swap(u, v);
            assert(u.x.a < v.x.a);
            mp[u.y].push_back({u.x, v.x});
        }
        for (auto elem : mp) {
            Num y = elem.first;
            auto sg = elem.second;
            sort(sg.begin(), sg.end());
            vector<array<Num, 2>> sg1;
            for (auto elem : sg) {
                if (!sg1.empty() && sg1.back()[1] == elem[0]) {
                    sg1.back()[1] = elem[1];
                } else {
                    sg1.push_back(elem);
                }
            }
            for (auto elem : sg1) {
                Vector u = {elem[0], y}, v = {elem[1], y};
                int len = elem[1].a - elem[0].a;
                for (int j = 0; j < i; ++j) {
                    u = rot45(u);
                    v = rot45(v);
                }
                /// cerr << i << " " << len << " " << u.x.a << " " << u.x.b << " " << u.y.a << " " << u.y.b << " "  << v.x.a << " " << v.x.b << " " << v.y.a << " " << v.y.b << endl;
                narr[i].push_back({len, {u, v}});
            }
        }
        for (auto elem : narr[i]) {
            mid = mid + elem.second[0] + elem.second[1];
            ++cnt;
        }
    }
    array<vector<pair<Vector, int>>, 4> arr;
    for (int i = 0; i < 4; ++i) {
        for (auto elem : narr[i]) {
            Vector m = (elem.second[0] + elem.second[1]) * cnt - mid;
            arr[i].push_back({m, elem.first});
        }
        sort(arr[i].begin(), arr[i].end());
    }
    array<vector<pair<Vector, int>>, 4> rotarr = arr;
    int ang = 0;
    while (true) {
        array<vector<pair<Vector, int>>, 4> rotarr1;
        ang += 45;
        for (int i = 0; i < 4; ++i) {
            rotarr1[(i + 1) % 4] = rotarr[i];
        }
        rotarr = rotarr1;
        for (int i = 0; i < 4; ++i) {
            for (auto& v : rotarr[i]) {
                v.first = rot45(v.first);
            }
            sort(rotarr[i].begin(), rotarr[i].end());
        }
        if (rotarr == arr) {
            cout << ang << "\n";
            return;
        }
    }
}

/// #define MULTITEST

signed main() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#endif
    int tst = 1;
#ifdef MULTITEST
    cin >> tst;
#endif // MULTITEST
    while (tst--) {
        solve_();
    }
    return 0;
}