// #include "/home/tikhon/Documents/programs/testlib/testlib.h"
#include "testlib.h"
#include <bits/stdc++.h>
 
using namespace std;
 
using ll = long long;
 
ll uniform(ll l, ll r, mt19937_64& rnd64) {
    return std::uniform_int_distribution<ll>(l, r)(rnd64);
}
 
mt19937_64 rnd64;
 
struct Hoglin {
    ll cur_pos;
    ll left_view;
    ll right_view;
    ll real_left_block;
    ll real_right_block;
 
    Hoglin(ll n)
            : left_view(1), right_view(n),
            real_left_block(0), real_right_block(n+1) {
        cur_pos = uniform(1, n, rnd64);
    }
 
    int upd(ll new_block) {
        // check catch
        if (new_block == cur_pos) {
            return 2;
        }
 
        // upd real blocks
        if (new_block < cur_pos) {
            real_left_block = max(real_left_block, new_block);
        } else {
            real_right_block = min(real_right_block, new_block);
        }
 
        // try to move
        ll new_pos = uniform(left_view, right_view, rnd64);
        if (new_pos <= real_left_block) {
            left_view = real_left_block + 1;
            return 1;
        }
        if (new_pos >= real_right_block) {
            right_view = real_right_block - 1;
            return 1;
        }
 
        cur_pos = new_pos;
        return 0;
    }
 
};
 
int main(int argc, char* argv[]) {
    registerInteraction(argc, argv);
    
    ll n = inf.readLong();
    int t = inf.readInt();
 
    ll seed = inf.readLong();
    rnd64.seed(seed);
 
    cout << n << ' ' << t << endl;

    const int q_limit = 200'000;
    int left_q = q_limit;
    int caught = 0;

    while (left_q > 0 && caught < t) {
        Hoglin hoglin(n);

        while (left_q > 0 && caught < t) {
            ll new_block = ouf.readLong(0, n);
            left_q--;
            int status = hoglin.upd(new_block);

            if (status == 2) {
                caught += 1;
            }
            if (status == 2 && caught == t) {
                status = 3;
            }
            if (status != 3 && left_q == 0) {
                status = -1;
            }

            cout << status << endl;

            if (status == 2 || status == 3) {
                break;
            }
        }
    }

    if (caught == t) {
        quitf(_ok, "caught %d hoglins in %d queries", t, q_limit - left_q);
    } else {
        quitf(_wa, "spent %d queries and caught %d hoglins", q_limit, caught);
    }
}
