#include <bits/stdc++.h>
using namespace std;

using ll = int64_t;

int main(){
	ios_base::sync_with_stdio(false), cin.tie(nullptr);
	int N, M;
	cin >> N >> M;
	vector<vector<pair<int, ll> > > adj(N), radj(N);
	for(int i = 0; i < M; i++){
		int u, v;
		ll t;
		cin >> u >> v >> t;
		u--; v--;
		adj[u].push_back({v, t});
		radj[v].push_back({u, t});
	}
	const ll DINF = 1e18;
	vector<ll> dist(N);
	{
		dist = vector<ll>(N, DINF);
		priority_queue<pair<ll, int>, vector<pair<ll, int> >, greater<pair<ll, int> > > pq;
		dist[N-1] = 0;
		pq.push({dist[N-1], N-1});
		while(!pq.empty()){
			auto [d, v] = pq.top();
			pq.pop();
			if(d != dist[v]) continue;
			for(auto [w, l] : radj[v]){
				if(dist[w] > d + l){
					dist[w] = d + l;
					pq.push({dist[w], w});
				}
			}
		}	
		if(dist[0] == DINF){
			cout << -1 << '\n';
			exit(0);
		}
	}
	int INF = 1e9;
	vector<int> incomp(N, INF);
	priority_queue<pair<int, int>, vector<pair<int, int> >, greater<pair<int, int> > > pq;
	for(int i = 0; i < N; i++){
		if(dist[i] == DINF){
			incomp[i] = 0;
			pq.push({incomp[i], i});
		}
	}
	vector<int> sp_count(N);
	for(int v = 0; v < N; v++){
		for(auto [w, l] : radj[v]){
			if(w == N-1) continue;
			int is_sp = (dist[v] + l == dist[w]);
			if(is_sp){
				sp_count[w]++;
			}
		}
	}
	vector<int> vis(N, 0);
	while(!pq.empty()){
		auto [d, v] = pq.top();
		pq.pop();
		if(d != incomp[v]) continue;
		for(auto [w, l] : radj[v]){
			if(w == N-1) continue;
			if(incomp[w] > d + 1){
				incomp[w] = d + 1;
				pq.push({incomp[w], w});
			}
			int is_sp = (dist[v] + l == dist[w]);
			if(is_sp){
				if(!vis[v]){
					sp_count[w]--;
					if(sp_count[w] == 0){
						if(incomp[w] > d){
							incomp[w] = d;
							pq.push({incomp[w], w});
						}
					}
				}
			}
		}
		vis[v] = 1;
	}
	if(incomp[0] == INF){
		cout << N << '\n';
	} else {
		cout << (incomp[0] - 1) << '\n';
	}
}
