///////////////////////////////    _LeMur_
#define _CRT_SECURE_NO_WARNINGS
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <cstring>
#include <complex>
#include <cassert>
#include <cfloat>
#include <memory>
#include <chrono>
#include <random>
#include <limits>
#include <bitset>
#include <cstdio>
#include <vector>
#include <string>
#include <stack>
#include <tuple>
#include <queue>
#include <ctime>
#include <cmath>
#include <list>
#include <map>
#include <set>

using namespace std;

const int N = 500005;
const int inf = 1000 * 1000 * 1000;
const int mod = 998244353;
// mt19937 myrand(chrono::steady_clock::now().time_since_epoch().count());
mt19937 myrand(373);

int n, m;

vector < pair<int, int> > g[N], gr[N];

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);

  cin >> n >> m;

  for (int i = 1; i <= m; i++) {
    int a, b, c;
    cin >> a >> b >> c;
    g[a].emplace_back(b, c);
    gr[b].emplace_back(a, c);
  }

  vector <bool> mark(n + 1, false);
  queue <int> q;
  q.push(n);
  mark[n] = true;

  while (!q.empty()) {
    int v = q.front();
    q.pop();

    for (auto [to, _]: gr[v]) {
      if (mark[to]) continue;
      mark[to] = true;
      q.push(to);
    }
  }

  vector <int> dist(n + 1, inf);
  for (int i = 1; i <= n; i++) {
    if (!mark[i]) {
      dist[i] = 0;
      q.push(i);
    }
  }

  while (!q.empty()) {
    int v = q.front();
    q.pop();

    for (auto [to, _]: gr[v]) {
      if (dist[to] != inf || to == n) continue;
      dist[to] = dist[v] + 1;
      q.push(to);
    }
  }

  vector <long long> reverse_dist(n + 1, inf * 1ll * inf);
  set < pair<long long, int> > Q;
  reverse_dist[n] = 0;
  Q.insert(make_pair(reverse_dist[n], n));

  while (!Q.empty()) {
    int v = Q.begin() -> second;
    Q.erase(Q.begin());

    for (auto [to, len]: gr[v]) {
      if (reverse_dist[v] + len < reverse_dist[to]) {
        Q.erase(make_pair(reverse_dist[to], to));
        reverse_dist[to] = reverse_dist[v] + len;
        Q.insert(make_pair(reverse_dist[to], to));
      }
    }
  }

  // for (int i = 1; i <= n; i++) {
  //   cout << dist[i] << " ";
  // }
  // cout << endl;

  // for (int i = 1; i <= n; i++) {
  //   cout << reverse_dist[i] << " ";
  // }
  // cout << endl;

  // for (int i = 1; i <= n; i++) {
  //   cout << mark[i] << " ";
  // }
  // cout << endl;

  if (reverse_dist[1] == inf * 1ll * inf) {
    cout << -1 << endl;
    return 0;
  }

  int ina = 1, inb = n, answ = 0;
  while (ina <= inb) {
    int mid = (ina + inb) / 2;

    if (dist[1] <= mid) {
      inb = mid - 1;
      continue;
    }

    vector <bool> used(n + 1, false);
    queue <int> q;
    used[1] = true;
    q.push(1);

    while (!q.empty()) {
      int v = q.front();
      q.pop();

      for (auto [to, len]: g[v]) {
        if (dist[to] <= mid) continue;
        if (reverse_dist[v] != len + reverse_dist[to]) continue;
        if (used[to]) continue;
        used[to] = true;
        q.push(to);
      }
    }

    if (used[n]) {
      answ = mid;
      ina = mid + 1;
    } else {
      inb = mid - 1;
    }
  }

  cout << answ << endl;
  return 0;
}
