#include "testlib.h"

using std::vector;
using std::pair;

const int MAXN = 200'000;
const int MAXA = 1'000'000'000;
const long long MAXD = 1'000'000'000'000'000LL;
const int MAXL = 1'000'000'000;
const long long MAXT = 1'000'000'000'000'000LL;

int main(int argc, char **argv) {
  registerValidation(argc, argv);
  int t = inf.readInt(1, 1000, "T");
  inf.readEoln();
  int sn = 0, sm = 0, sq = 0;
  for (int test = 0; test < t; test++) {
    setTestCase(test);
    int n = inf.readInt(1, MAXN, "n");
    inf.readSpace();
    int m = inf.readInt(1, MAXN, "m");
    inf.readSpace();
    int q = inf.readInt(1, MAXN, "q");
    inf.readEoln();
    sn += n; sm += m; sq += q;
    ensuref(sn <= MAXN, "total n is too big");
    ensuref(sm <= MAXN, "total m is too big");
    ensuref(sq <= MAXN, "total q is too big");
    vector<int> a = inf.readInts(n, 1, MAXA, "a");
    inf.readEoln();
    vector<long long> d = inf.readLongs(n, 1, MAXD, "d");
    inf.readEoln();
    vector<int> l = inf.readInts(m, 1, MAXL, "l");
    inf.readEoln();
    vector<long long> t = inf.readLongs(q, 1, MAXT, "t");
    inf.readEoln();

    vector<pair<long long, int>> v(n);
    for (int i = 0; i < n; i++) {
      v[i] = {d[i], a[i]};
    }
    sort(v.begin(), v.end());
    long long cur_tot = 0;
    for (int i = 0; i < n; i++) {
      cur_tot += v[i].second;
      ensuref(cur_tot <= v[i].first, "Test %d can't make all tasks within deadlines: %lld total time to deadline %lld", test, cur_tot, v[i].first);
    }
  }
  inf.readEof();
}
