///////////////////////////////    _LeMur_
#define _CRT_SECURE_NO_WARNINGS
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <cstring>
#include <complex>
#include <cassert>
#include <cfloat>
#include <memory>
#include <chrono>
#include <random>
#include <limits>
#include <bitset>
#include <cstdio>
#include <vector>
#include <string>
#include <stack>
#include <tuple>
#include <queue>
#include <ctime>
#include <cmath>
#include <list>
#include <map>
#include <set>

using namespace std;

const int N = 10005;
const int inf = 1000 * 1000 * 1000;
const int mod = 998244353;
// mt19937 myrand(chrono::steady_clock::now().time_since_epoch().count());
mt19937 myrand(373);

int t;
int n, m;
int a[N], b[N];
int ind_a[N], ind_b[N];

int x[N], y[N];

int S, T;

struct edge {
  int a, b, c, flow;
  int id;
};

struct Dinic {
  int mn, mx;
  vector <edge> G;
  vector < vector<int> > g;
  vector <int> d;
  vector <int> pos;

  Dinic(int _mn, int _mx) {
    mn = _mn;
    mx = _mx;
    g.resize(mx + 1);
    d.resize(mx + 1);
    pos.resize(mx + 1);
  }

  void add_edge(int a, int b, int c, int id) {
    edge e1 = {a, b, c, 0, id};
    edge e2 = {b, a, 0, 0, id};
    g[a].push_back((int)G.size());
    G.push_back(e1);
    g[b].push_back((int)G.size());
    G.push_back(e2);
  }

  bool bfs() {
    for (int i = mn; i <= mx; i++) {
      d[i] = -1;
    }
    queue <int> q;
    d[S] = 0;
    q.push(S);
    while (!q.empty()) {
      int v = q.front();
      q.pop();
      for (int i = 0; i < (int)g[v].size(); i++) {
        int id = g[v][i];
        int to = G[id].b;
        if (G[id].c == G[id].flow) continue;
        if (d[to] == -1) {
          d[to] = d[v] + 1;
          q.push(to);
        }
      }
    }
    return d[T] != -1;
  }

  int dfs(int v, int flow) {
    if (v == T || flow == 0) return flow;
    for (; pos[v] < (int)g[v].size(); pos[v]++) {
      int id = g[v][pos[v]];
      int to = G[id].b;
      if (d[to] != d[v] + 1) continue;
      int x = dfs(to, min(flow, G[id].c - G[id].flow));
      if (x != 0) {
        G[id].flow += x;
        G[id ^ 1].flow -= x;
        return x;
      }
    }
    return 0;
  }

  int maxFlow() {
    int answ = 0;
    while (bfs()) {
      for (int i = mn; i <= mx; i++) {
        pos[i] = 0;
      }
      while (true) {
        int x = dfs(S, inf);
        if (x == 0) break;
        answ += x;
      }
    }
    return answ;
  }

  bool check(int st, int en, int val) {
    queue <int> q;
    vector <bool> used(3 * n + 1, false);

    used[st] = true;
    q.push(st);

    while (!q.empty()) {
      int v = q.front();
      q.pop();

      if (v >= 1 && v <= n) {
        for (int i = 0; i < (int)g[v].size(); i++) {
          int ind = g[v][i];
          if (G[ind].b >= n + 1 && G[ind].b <= 2 * n) {
            if (!used[G[ind].b] && G[ind].c - G[ind].flow == val) {
              used[G[ind].b] = true;
              q.push(G[ind].b);
            }
          }
        }
      } else {
        for (int i = 0; i < (int)g[v].size(); i++) {
          int ind = g[v][i];
          if (G[ind].b >= 1 && G[ind].b <= n) {
            if (!used[G[ind].b] && G[ind].c - G[ind].flow == val) {
              used[G[ind].b] = true;
              q.push(G[ind].b);
            }
          }
        }
      }
    }

    return used[en];
  }
};

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);

  cin >> t;

  while (t--) {
    cin >> n;

    for (int i = 1; i <= n; i++) {
      cin >> a[i];
      ind_a[ a[i] ] = i;
    }
    for (int i = 1; i <= n; i++) {
      cin >> b[i];
      ind_b[ b[i] ] = i;
    }

    ind_a[n + 1] = n + 1;
    ind_b[n + 1] = n + 1;

    cin >> m;
    for (int i = 1; i <= m; i++) {
      cin >> x[i];
    }
    for (int i = 1; i <= m; i++) {
      cin >> y[i];
    }

    bool flag = true;

    vector < vector<int> > A;
    vector <int> cap1;

    x[0] = 0;
    x[m + 1] = n + 1;

    int cnt = 0, lst = 0;
    for (int i = 1; i <= m + 1; i++) {
      if (x[i] != -1) {
        if (lst > ind_a[x[i]]) {
          flag = false;
          break;
        }

        vector <int> cur;
        for (int j = lst + 1; j < ind_a[x[i]]; j++) {
          cur.push_back(a[j]);
        }

        if ((int)cur.size() < cnt) {
          flag = false;
          break;
        }

        if (cnt > 0) {
          A.push_back(cur);
          cap1.push_back(cnt);
        }

        if (i != m + 1) {
          A.push_back({x[i]});
          cap1.push_back(1);
        }

        lst = ind_a[x[i]];
        cnt = 0;
      } else {
        ++cnt;
      }
    }

    if (!flag) {
      cout << "Inconsistent" << endl;
      continue;
    }

    vector < vector<int> > B;
    vector <int> cap2;

    y[0] = 0;
    y[m + 1] = n + 1;

    cnt = 0, lst = 0;
    for (int i = 1; i <= m + 1; i++) {
      if (y[i] != -1) {
        if (lst > ind_b[y[i]]) {
          flag = false;
          break;
        }

        vector <int> cur;
        for (int j = lst + 1; j < ind_b[y[i]]; j++) {
          cur.push_back(b[j]);
        }

        if ((int)cur.size() < cnt) {
          flag = false;
          break;
        }

        if (cnt > 0) {
          B.push_back(cur);
          cap2.push_back(cnt);
        }

        if (i != m + 1) {
          B.push_back({y[i]});
          cap2.push_back(1);
        }

        lst = ind_b[y[i]];
        cnt = 0;
      } else {
        ++cnt;
      }
    }

    if (!flag) {
      cout << "Inconsistent" << endl;
      continue;
    }

    S = 0;
    T = 2 * n + 1;

    Dinic D(S, T);
    for (int i = 0; i < (int)A.size(); i++) {
      D.add_edge(S, i + 1, cap1[i], -1);
    }
    for (int i = 0; i < (int)B.size(); i++) {
      D.add_edge(n + i + 1, T, cap2[i], -1);
    }

    vector <int> group1(n + 1, -1);
    vector <int> group2(n + 1, -1);

    for (int i = 0; i < (int)A.size(); i++) {
      for (int val: A[i]) {
        group1[val] = i + 1;
      }
    }
    for (int i = 0; i < (int)B.size(); i++) {
      for (int val: B[i]) {
        group2[val] = i + 1 + n;
      }
    }

    vector <int> mas(n + 1);

    int it = (int)D.G.size();
    for (int i = 1; i <= n; i++) {
      if (group1[i] == -1 || group2[i] == -1) continue;
      mas[i] = (int)D.G.size();
      D.add_edge(group1[i], group2[i], 1, i);
    }

    if (D.maxFlow() != m) {
      cout << "Inconsistent" << endl;
      continue;
    }

    vector <char> answ(n + 1, '?');
    for (int i = 1; i <= n; i++) {
      if (group1[i] == -1 || group2[i] == -1) {
        answ[i] = 'N';
        continue;
      }

      if (D.G[ mas[i] ].flow == 1) {
        answ[i] = 'Y';
      } else {
        answ[i] = 'N';
      }

      if (D.check(group1[i], group2[i], (answ[i] == 'N') ? 0 : 1)) {
        answ[i] = '?';
      }
    }

    for (int i = 1; i <= n; i++) {
      cout << answ[i];
    }
    cout << endl;
  }
  return 0;
}
