#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

struct Test {
    int n;
    vector<pair<int, int>> edges;
    vector<int> a;

    void Read() {
        n = inf.readInt();
        a = inf.readIntegers(2 * n);
        edges.reserve(2 * n - 1);
        for (int i = 0; i < 2 * n - 1; i++) {
            int s = inf.readInt();
            int f = inf.readInt();
            s--, f--;
            edges.emplace_back(s, f);
        }
    }
};

int ReadAns(InStream& stream, Test test) {
    int k = stream.readInt(0, test.n, "k");
    map<int, int> q;
    for (int i = 0; i < k; i++) {
        int x = stream.readInt(1, 2 * test.n, format("i[%d]", i + 1));
        int y = stream.readInt(1, 2 * test.n, format("j[%d]", i + 1));
        x--, y--;
        if (x == y) {
            stream.quitf(_wa, "cannot swap for equal machines (swap %d)", i + 1);
        }
        if (q.find(x) != q.end()) {
            stream.quitf(_wa, "machine %d participate in at least two swaps %d and %d", x + 1, q[x] + 1, i + 1);
        }
        q[x] = i;
        if (q.find(y) != q.end()) {
            stream.quitf(_wa, "machine %d participate in at least two swaps %d and %d", y + 1, q[y] + 1, i + 1);
        }
        q[y] = i;
        swap(test.a[x], test.a[y]);
    }
    int res = 0;
    for (auto [x, y] : test.edges) {
        res += (int)(test.a[x] == test.a[y]);
    }
    return res;
}

int main(int argc, char** argv) {
    registerTestlibCmd(argc, argv);

    int t = inf.readInt();

    for (int it = 0; it < t; it++) {
        setTestCase(it + 1);

        Test test;
        test.Read();

        int pans = ReadAns(ouf, test);
        int jans = ReadAns(ans, test);

        if (pans > jans) {
            quitf(_fail, "pans=%d > jans=%d", pans, jans);
        } else if (pans < jans) {
            quitf(_wa, "pans=%d < jans=%d", pans, jans);
        }
    }

    quitf(_ok, "all answers are correct");

    return 0;
}
