#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

std::vector<int> RandSet(int n, int k, int w) {
    if (w == 0) {
        auto res = rnd.distinct(k, 0, n - 1);
        sort(res.begin(), res.end());
        return res;
    }
    std::vector<int> ans;
    for (int i = 0; i < k; i++) {
        ans.push_back(rnd.wnext(n - k + 1, w));
    }
    std::sort(ans.begin(), ans.end());
    for (int i = 0; i < k; i++) {
        ans[i] += i;
    }
    return ans;
}

std::vector<int> Divide(int n, int k, int w) {
    if (k == 1) {
        return {n};
    }
    std::vector<int> pos = RandSet(n - 1, k - 1, w);
    vector<int> sz(k, 0);
    sz[0] = pos[0] + 1;
    for (int i = 0; i + 1 < k - 1; i++) {
        sz[i + 1] = pos[i + 1] - pos[i];
    }
    sz[k - 1] = n - pos[k - 2] - 1;
    shuffle(sz.begin(), sz.end());
    return sz;
}

const int kMaxN = 100'000;

vector<pair<int, int>> RandTree(int n, int w) {
    vector<int> q = rnd.perm(n);
    vector<pair<int, int>> edges;
    for (int i = 1; i < n; i++) {
        edges.emplace_back(rnd.wnext(i, w), i);
    }
    shuffle(edges.begin(), edges.end());
    for (auto& [s, f] : edges) {
        if (rnd.next(2)) {
            swap(s, f);
        }
        s = q[s];
        f = q[f];
    }
    return edges;
}

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);

    int sn = opt<int>("n", kMaxN);
    int t = opt<int>("t", 1);
    int w = opt<int>("w", 0);

    vector<int> n_list = Divide(sn, t, 0);

    println(n_list.size());
    for (int n : n_list) {
        vector<int> a(2 * n);
        for (int i = 0; i < 2 * n; i++) {
            a[i] = (i / 2) + 1;
        }
        shuffle(a.begin(), a.end());
        println(n);
        println(a);
        auto edges = RandTree(2 * n, w);
        for (auto [s, f] : edges) {
            println(s + 1, f + 1);
        }
    }

    return 0;
}
