#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

std::vector<int> RandSet(int n, int k, int w) {
    if (w == 0) {
        auto res = rnd.distinct(k, 0, n - 1);
        sort(res.begin(), res.end());
        return res;
    }
    std::vector<int> ans;
    for (int i = 0; i < k; i++) {
        ans.push_back(rnd.wnext(n - k + 1, w));
    }
    std::sort(ans.begin(), ans.end());
    for (int i = 0; i < k; i++) {
        ans[i] += i;
    }
    return ans;
}

std::vector<int> Divide(int n, int k, int w) {
    if (k == 1) {
        return {n};
    }
    std::vector<int> pos = RandSet(n - 1, k - 1, w);
    vector<int> sz(k, 0);
    sz[0] = pos[0] + 1;
    for (int i = 0; i + 1 < k - 1; i++) {
        sz[i + 1] = pos[i + 1] - pos[i];
    }
    sz[k - 1] = n - pos[k - 2] - 1;
    shuffle(sz.begin(), sz.end());
    return sz;
}

const int kMaxN = 100'000;

vector<int> ObfuscateTree(int n, vector<pair<int, int>>& edges) {
    vector<int> q = rnd.perm(n);
    shuffle(edges.begin(), edges.end());
    for (auto& [s, f] : edges) {
        if (rnd.next(2)) {
            swap(s, f);
        }
        s = q[s];
        f = q[f];
    }
    return q;
}

vector<pair<int, int>> RandTree(int n, int p, int w, vector<pair<int, int>>& mat) {
    for (int i = 0; i < n - p; i++) {
        mat.emplace_back(2 * i, 2 * i + 1);
    }
    auto edges = mat;
    for (int i = n - p; i < n; i++) {
        mat.emplace_back(2 * i, 2 * i + 1);
    }
    for (int i = 1; i < n - p; i++) {
        int par = rnd.wnext(i, w);
        int to = rnd.wnext(2, w);
        int from = 1 - rnd.wnext(2, w);
        edges.emplace_back(2 * par + to, 2 * i + from);
    }
    for (int i = 2 * (n - p); i < 2 * n; i++) {
        int par = rnd.wnext(i, w);
        edges.emplace_back(par, i);
    }
    auto q = ObfuscateTree(2 * n, edges);
    for (auto& [s, f] : mat) {
        s = q[s];
        f = q[f];
    }
    return edges;
}

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);

    int sn = opt<int>("n", kMaxN);
    int t = opt<int>("t", 1);
    int w = opt<int>("w", 0);
    int p = opt<int>("p", 0);
    int c = opt<int>("c", -1);

    vector<int> n_list = Divide(sn, t, 0);

    println(n_list.size());
    for (int n : n_list) {
        vector<pair<int, int>> mat;
        int cp = p;
        if (cp == 0) {
            cp = rnd.next((int)sqrtl(n));
        }
        auto edges = RandTree(n, cp, w, mat);
        vector<int> a(2 * n);
        if (c == -1) {
            for (int i = 0; i < 2 * n; i++) {
                a[i] = (i / 2) + 1;
            }
            shuffle(a.begin(), a.end());
        } else {
            c = min(c, n);
            shuffle(mat.begin(), mat.end());
            auto szs = Divide(n, c, 0);
            int L = 0;
            for (int sz : szs) {
                int R = L + sz;
                for (int i = 0; i < sz; i++) {
                    auto [s, f] = mat[L + i];
                    a[s] = L + i + 1;
                    a[f] = L + ((i + 1) % sz) + 1;
                }
                L = R;
            }
        }
        println(n);
        println(a);
        for (auto [s, f] : edges) {
            println(s + 1, f + 1);
        }
    }

    return 0;
}
