#include "testlib.h"
#include <bits/stdc++.h>

using namespace std;

class DSU {
public:
    explicit DSU(int n) : par(n) {
        iota(par.begin(), par.end(), 0);
    }

    bool Merge(int s, int f) {
        s = FindSet(s);
        f = FindSet(f);
        if (s == f) {
            return false;
        }
        par[s] = f;
        return true;
    }

private:
    int FindSet(int p) {
        if (p == par[p]) {
            return p;
        }
        return par[p] = FindSet(par[p]);
    }

    vector<int> par;
};

const int kMaxN = 100'000;
const int kMaxT = 100'000;

int main(int argc, char **argv) {
    registerValidation(argc, argv);

    int t = inf.readInt(1, kMaxT, "t");
    inf.readEoln();

    int sum_n = 0;
    for (int test = 0; test < t; test++) {
        setTestCase(test + 1);

        int n = inf.readInt(1, kMaxN, "n");
        inf.readEoln();

        sum_n += n;
        ensuref(sum_n <= kMaxN, "sum of n exceed %d", kMaxN);

        vector<int> a = inf.readIntegers(2 * n, 1, n, "a");
        inf.readEoln();

        vector<int> cnt(n, 0);
        for (int i : a) {
            cnt[i - 1]++;
        }
        for (int i = 0; i < n; i++) {
            ensuref(cnt[i] == 2, "%d appears %d != 2 times in a", i + 1, cnt[i]);
        }

        DSU dsu(2 * n);
        for (int i = 0; i < 2 * n - 1; i++) {
            int s = inf.readInt(1, 2 * n, string(format("s[%d]", i + 1)));
            inf.readSpace();
            int f = inf.readInt(1, 2 * n, string(format("f[%d]", i + 1)));
            inf.readEoln();
            s--, f--;
            ensuref(s != f, "s[%d] == f[%d]", i + 1, i + 1);
            ensuref(dsu.Merge(s, f), "the graph is not connected");
        }
    }

    inf.readEof();

    return 0;
}