#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>

using namespace std;

// #define int long long
#define pii pair<int, int>
#define x first
#define y second
typedef long long ll;
typedef long double ld;
const int MAXN = 2e5;
int a[MAXN];
vector<int> adj[MAXN];
vector<pii> pairs;
int dp[MAXN][2];
int chosen_with[MAXN];

void dfs(int u, int p=-1) {
    int summ_1 = 0;
    for (auto v : adj[u]) {
        if (v != p) {
            dfs(v, u);
            summ_1 += dp[v][1];
        }
    }
    dp[u][0] = dp[u][1] = summ_1;
    chosen_with[u] = -1;
    for (auto v : adj[u]) {
        if (v != p) {
            int new_1 = summ_1 - dp[v][1] + dp[v][0] + 1;
            if (new_1 > dp[u][1]) {
                dp[u][1] = new_1;
                chosen_with[u] = v;
            }
        }
    }
}

void construct_pairs(int u, int val, int p=-1) {
    if (chosen_with[u] == -1) val = 0;
    if (val == 1) {
        pairs.emplace_back(u, chosen_with[u]);
        for (auto v : adj[u]) {
            if (v != p && v != chosen_with[u]) {
                construct_pairs(v, 1, u);
            }
            else if (v == chosen_with[u]) {
                construct_pairs(v, 0, u);
            }
        }
    }
    else {
        for (auto v : adj[u]) {
            if (v != p) {
                construct_pairs(v, 1, u);
            }
        }
    }
}

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < 2 * n; ++i) {
        cin >> a[i];
        --a[i];
        adj[i].clear();
    }
    pairs.clear();
    for (int i = 0; i < 2 * n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        --u; --v;
        adj[u].push_back(v);
        adj[v].push_back(u);
    }
    dfs(0);
    construct_pairs(0, 1);
    vector<int> ind_of_pair(2 * n, -1);
    vector<int> nums_with_class(n, 0);
    for (int i = 0; i < 2 * n; ++i) {
        nums_with_class[a[i]] ^= i;
    }
    for (int i = 0; i < (int)pairs.size(); ++i) {
        ind_of_pair[pairs[i].x] = i;
        ind_of_pair[pairs[i].y] = i;
    }
    vector<bool> been(n, false);
    vector<pii> res;
    for (int i = 0; i < (int)pairs.size(); ++i) {
        if (a[pairs[i].x] == a[pairs[i].y] || been[i]) {
            been[i] = true;
            continue;
        }
        int friend_of_x = nums_with_class[a[pairs[i].x]] ^ pairs[i].x;
        if (ind_of_pair[friend_of_x] == -1) {
            int curr_pair = i;
            int curr_elem = pairs[i].y;
            vector<int> help;
            help.push_back(pairs[i].x);
            help.push_back(pairs[i].y);
            while (true) {
                been[curr_pair] = true;
                int curr_friend = nums_with_class[a[curr_elem]] ^ curr_elem;
                int next_ind = ind_of_pair[curr_friend];
                if (next_ind == -1) {
                    break;
                }
                curr_pair = next_ind;
                curr_elem = pairs[curr_pair].x ^ pairs[curr_pair].y ^ curr_friend;
                help.push_back(curr_friend);
                help.push_back(curr_elem);
            }
            for (int j = 0; j < (int)help.size() - 2 - j; ++j) {
                res.emplace_back(help[j], help[(int)help.size() - 2 - j]);
            }
            res.emplace_back(help.back(), nums_with_class[a[pairs[i].x]] ^ pairs[i].x);
            continue;
        }
        int friend_of_y = nums_with_class[a[pairs[i].y]] ^ pairs[i].y;
        if (ind_of_pair[friend_of_y] == -1) {
            int curr_pair = i;
            int curr_elem = pairs[i].x;
            vector<int> help;
            help.push_back(pairs[i].y);
            help.push_back(pairs[i].x);
            while (true) {
                been[curr_pair] = true;
                int curr_friend = nums_with_class[a[curr_elem]] ^ curr_elem;
                int next_ind = ind_of_pair[curr_friend];
                if (next_ind == -1) {
                    break;
                }
                curr_pair = next_ind;
                curr_elem = pairs[curr_pair].x ^ pairs[curr_pair].y ^ curr_friend;
                help.push_back(curr_friend);
                help.push_back(curr_elem);
            }
            for (int j = 0; j < (int)help.size() - 2 - j; ++j) {
                res.emplace_back(help[j], help[(int)help.size() - 2 - j]);
            }
            res.emplace_back(help.back(), nums_with_class[a[pairs[i].y]] ^ pairs[i].y);
            continue;
        }
    }
    for (int i = 0; i < (int)pairs.size(); ++i) {
        if (been[i]) {
            continue;
        }
        int curr_pair = i;
        int curr_elem = pairs[i].y;
        vector<int> help;
        help.push_back(pairs[i].x);
        help.push_back(pairs[i].y);
        while (true) {
            been[curr_pair] = true;
            int curr_friend = nums_with_class[a[curr_elem]] ^ curr_elem;
            int next_ind = ind_of_pair[curr_friend];
            if (next_ind == i) {
                break;
            }
            curr_pair = next_ind;
            curr_elem = pairs[curr_pair].x ^ pairs[curr_pair].y ^ curr_friend;
            help.push_back(curr_friend);
            help.push_back(curr_elem);
        }
        for (int j = 0; j < (int)help.size() - 2 - j; ++j) {
            res.emplace_back(help[j], help[(int)help.size() - 2 - j]);
        }
    }
    cout << res.size() << "\n";
    for (auto elem : res) {
        cout << elem.first + 1 << " " << elem.second + 1 << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LC
    freopen("/Users/Iurii.Zaitsev/TUM/ICPC/y1/nerc_test/input.txt", "r", stdin);
    freopen("/Users/Iurii.Zaitsev/TUM/ICPC/y1/nerc_test/output.txt", "w", stdout);

#endif
    int t = 1;
    cin >> t;
    for (int tt =0; tt < t; tt++) {
        solve();
    }

    return 0;
}
