#include <bits/stdc++.h>
using namespace std;

namespace std {

template<class Fun>
class y_combinator_result {
	Fun fun_;
public:
	template<class T>
	explicit y_combinator_result(T &&fun): fun_(std::forward<T>(fun)) {}

	template<class ...Args>
	decltype(auto) operator()(Args &&...args) {
		return fun_(std::ref(*this), std::forward<Args>(args)...);
	}
};

template<class Fun>
decltype(auto) y_combinator(Fun &&fun) {
	return y_combinator_result<std::decay_t<Fun>>(std::forward<Fun>(fun));
}

} // namespace std

void solve(){
	int N;
	cin >> N;
	N *= 2;
	vector<int> A(N);
	for(int i = 0; i < N; i++){
		cin >> A[i];
		A[i]--;
	}
	vector<vector<int> > tree(N);
	for(int i = 0; i < N-1; i++){
		int u, v;
		cin >> u >> v;
		u--; v--;
		tree[u].push_back(v);
		tree[v].push_back(u);
	}
	vector<int> used(N, 0);
	vector<pair<int,int> > ans;
	vector<int> extra;
	y_combinator([&](auto self, int v, int p) -> void {
		for(int w : tree[v]){
			if(w == p) continue;
			self(w, v);
		}
		if(!used[v] && p >= 0 && !used[p]){
			used[v] = used[p] = 1;
			ans.push_back({v, p});
		} else if(!used[v]){
			used[v] = 1;
			extra.push_back(v);
		}
	})(0, -1);
	int real_ans = (int)ans.size();
	assert(extra.size() % 2 == 0);
	for(int i = 0; i < extra.size(); i += 2){
		ans.push_back({extra[i], extra[i+1]});
	}
	vector<int> match(N, -1);
	for(auto [x, y] : ans){
		match[x] = y;
		match[y] = x;
	}
	vector<vector<int> > where(N/2);
	for(int i = 0; i < N; i++){
		where[A[i]].push_back(i);
	}
	vector<int> other_instance(N, -1);
	for(int n = 0; n < N/2; n++){
		int x = where[n][0];
		int y = where[n][1];
		other_instance[x] = y;
		other_instance[y] = x;
	}
	vector<pair<int,int> > swaps;
	vector<int> done(N, 0);
	for(int i = 0; i < N; i++){
		if(done[i]) continue;
		int v = i;
		done[v] = 1;
		int need = v;
		while(match[v] != other_instance[need]){
			swaps.push_back({match[v], other_instance[need]});
			done[match[v]] = done[other_instance[need]] = 1;
			swap(A[match[v]], A[other_instance[need]]);
			need = other_instance[need];
			v = match[v];
			swap(v, need);
		}
		done[match[v]] = done[other_instance[need]] = 1;
	}
	cout << swaps.size() << '\n';
	for(auto [x, y] : swaps){
		cout << x+1 << ' ' << y+1 << '\n';
	}
}

int main(){
	ios_base::sync_with_stdio(false), cin.tie(nullptr);
	int T;
	cin >> T;
	while(T--) solve();
}
